"""Class to query database info

This is MySQL specific.

Author: Paulo Eduardo Neves <neves@inf.puc-rio.br>
"""

import InfoBase
import string

class Info(InfoBase.Info):
    #Are these commands in the SQL standard?
    queryTables = 'show tables'
    queryColumns = 'show columns from %s' 

    def type(self, table, column):
	"""Maps database types to #sqlvar types

	This looks like really MySQL specific
	"""
	for i in self.columnsData[table]:
	    if i[0] == column:
		colInfo = i
		break
	type = string.lower(colInfo[1]) #[1] is the pos for the type info
	if ((string.find(type, "char") != -1) or #gets char and varchar
	    (string.find(type, "set")  != -1) or 
	    (string.find(type, "enum") != -1) ):
            return 'string'
            
	if (string.find(type, "int") != -1):
	    return 'int'

        if (string.find(type, "date") != -1):
            return 'date'

        if (string.find(type, "time") != -1) :
            return 'timestamp'

        if (string.find(type, "text") != -1):
            return 'text'
	#else
	return 'float'
    
    def nullable(self, table, column):
	"This is really MySQL specific"
	for i in self.columnsData[table]:
	    if i[0] == column:
		colInfo = i
		break
	if colInfo[2] == "YES": #2 is the pos for null info
	    return 'optional'
	return ''

